#!/usr/local/bin/perl

#-------------------------------------------------------------------
#
#
#						Developed by Quicomm
#					   http:\\www.quicomm.com
#						All rights reserved
#					  
#					      July 16, 2004
#                             v4.0.0
#-------------------------------------------------------------------
print("Content-Type: text/html\n\n");

require "timelocal.pl";

$MasterHTMLDirectory = "";  #  EXAMPLE: /mnt/web/guide/myserver/www/utility
#
# IF you do NOT know the full path name to the directory in which you will be placing the mysql.htm page
# then uncomment the next two lines and run the script (mysql_command.cgi).  This will display the full path
# name to your cgi directory.  Change as needed to point to the directory in which the mysql.htm page will reside
# then assign to the variable $MasterHTMLDirectory above.  Recomment out the two lines after determining the path name.

# print `pwd`;
# exit 0;

# we recommend that you create a new directory on your site called "mysql".
# within this directory create four more directories beneath it, called "dump", "load", "export" and "import"
# these directories should have permission 775 or 777 (depends on how cgi scripts run on your server and what permissions
# are required to create and write files from Perl scripts).
# the "mysql" directory does NOT have to lie within your www or htdocs direcotry, hence for security you can keep this directory
# and all your MySQL data out of the path of http access

$DumpDirectory = "/yourpath/mysql/dump";  #  EXAMPLE: /mnt/web/guide/myserver/mysql/dump";
$LoadDirectory = "/yourpath/mysql/load";  #  EXAMPLE: /mnt/web/guide/myserver/mysql/load";
$ImportDirectory = "/yourpath/mysql/import";  #  EXAMPLE: /mnt/web/guide/myserver/mysql/import";
$ExportDirectory = "/yourpath/mysql/export";  #  EXAMPLE: /mnt/web/guide/myserver/mysql/export";

$DB_Host = ""; # you can often leave this blank and set to "" or set to "localhost"
$DB_Name = "";
$DB_User = ""; 
$DB_Password = ""; 

# you will have to enter the following password the first time you run the script.  After the first time, the password is automatically carried 
# over to the next page
$Script_Password = "";

# leave the following two variables blank if this script can be run from any IP address
# assign a from (beginning) and a to (ending) IP address range if you wish to limit the IP address range from which this script can be run
# assign both variables the same IP address if you only wish to let one IP address run this script

$Admin_From_IP_Address = "";  # the beginning of the range of IP address(es) which are permitted to run script
$Admin_To_IP_Address = ""; # the end of the range of IP address(es) which are permitted to run script

$Mailprog = '/usr/sbin/sendmail';  # this is the path to the email program (for sending out email).

# if you want to be notified anytime a user runs the script using the wrong password, enter your email below
# this is optional
$Notification_email_address = ""; # remember to escape \ the @ symbol, e.g. johndoe\@mycompany.com

# DO NOT MODIFY ANYTHING BELOW THIS LINE
# ---------------------------------------------------------------


use CGI;
$query = new CGI;

$IPAddress = $ENV{REMOTE_ADDR};


# check the IP address range of submission...if not in range, then notify and exit
if($Admin_From_IP_Address ne "")
{
	
	&Convert_IP_To_Decimal();
	$current_dec_ip_address = $decimal_ip_address;

	$IPAddress = $Admin_From_IP_Address;
	&Convert_IP_To_Decimal();
	$from_dec_ip_address = $decimal_ip_address;
	
	$IPAddress = $Admin_To_IP_Address;
	&Convert_IP_To_Decimal();
	$to_dec_ip_address = $decimal_ip_address;
	
	if($current_dec_ip_address < $from_dec_ip_address)
	{
		print "IP Address not in permissable range.";
		exit 0;
	}
	if($current_dec_ip_address > $to_dec_ip_address)
	{
		print "IP Address not in permissable range.";
		exit 0;
	}
}


$sql_command= $query->param('sql_command');
$script_password1= $query->param('password1');
$script_password2= $query->param('password2');
$script_password3= $query->param('password3');
$selected_table = $query->param('selected_table');

$dump_file_name = $query->param('dump_file');
$load_file_name = $query->param('load_file');
$import_file_name = $query->param('import_file');
$export_file_name = $query->param('export_file');

$import_format = $query->param('import_format');
$export_format = $query->param('export_format');
$gzip_export = $query->param('gzip_export');
$gzip_dump = $query->param('gzip_dump');
$import_delete_entries = $query->param('import_delete_entries');
$drop_table = $query->param('drop_table');

$date = $query->param('date');
$unix_time = $query->param('unix_time');

$action= $query->param('action');
$action =~ s/ //g;

use Mysql;
# connect to the DB
if (!($dbh = Mysql->Connect($DB_Host,$DB_Name,$DB_User,$DB_Password)))
{
	print "Could Not Connect to Database! Reason: ".($Mysql::db_errstr);
	exit;
}

if($action eq "") # this is the only thing we can do without a password and no action
{
	
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$password_entry = "<TR><TD><CENTER><FONT SIZE=\"-1\" FACE=\"Arial\">Password:<INPUT TYPE=password NAME=password1 VALUE=\"\" SIZE=15></FONT></CENTER></TD><TD WIDTH=175><CENTER></CENTER></TD></TR>";
	$password_entry2 = "<TR><TD><CENTER><FONT SIZE=\"-1\" FACE=\"Arial\">Password:<INPUT TYPE=password NAME=password2 VALUE=\"\" SIZE=15></FONT></CENTER></TD><TD WIDTH=175><CENTER></CENTER></TD></TR>";
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER/$password_entry/;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER/$password_entry2/;
	$htmlFile =~ s/ACTION_RESULTS//;
	$htmlFile =~ s/CONVERT_DATE//;
	$htmlFile =~ s/CONVERT_TIME//;
	print $htmlFile;
	exit 0;
}

if($action eq "DisplayHelp") # display the help page
{
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_help.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	print $htmlFile;
	exit 0;
}

if($script_password1 ne "")
{
	$the_password = $script_password1;
}
elsif($script_password2 ne "")
{
	$the_password = $script_password2;
}
elsif($script_password3 ne "")
{
	$the_password = $script_password3;
}

if($the_password ne "$Script_Password")
{
	&Handle_Notification();
	print "Invalid Password";
	exit 0;
}

if($action eq "RunCommand")
{
	&SubmitQuery();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/$query_results/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "ShowStructure")
{
	&ShowStructure();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/$table_structure_edit_box/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "DumpTable")
{
	&DumpTable();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	if($dump_file_name eq "")
	{
		$htmlFile =~ s/ACTION_RESULTS/$dump_file/;
	}
	else
	{
		if (!open(DATA, ">$DumpDirectory/$dump_file_name"))
		{
			print "Cannot open $DumpDirectory/$dump_file_name<br>";
			print "Check the permissions on this directory.";
			exit 0;
		}
		print DATA $dump_file;
		close DATA;
		
		if($gzip_dump)
		{
			`gzip $DumpDirectory/$dump_file_name`;
			$htmlFile =~ s/ACTION_RESULTS/Data written to file $DumpDirectory\/$dump_file_name.gz/;
		}
		else
		{
			$htmlFile =~ s/ACTION_RESULTS/Data written to file $DumpDirectory\/$dump_file_name/;
		}
	}
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "LoadTable")
{
	&LoadTable();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/Table $created_table_name created and loaded./;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "ExportData")
{
	&ExportData();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	if($gzip_export)
	{
		`gzip $ExportDirectory/$export_file_name`;
		$htmlFile =~ s/ACTION_RESULTS/Table $selected_table exported to file $ExportDirectory\/$export_file_name.gz/;
	}
	else
	{
		$htmlFile =~ s/ACTION_RESULTS/Table $selected_table exported to file $ExportDirectory\/$export_file_name/;
	}
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "ImportData")
{
	&ImportData();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/$numberOfImportedEntries lines imported into table $selected_table from $ImportDirectory\/$import_file_name./;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "ShowTableSize(s)")
{
	&Show_Table_Sizes();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/$table/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

if($action eq "Convert")
{
	&Convert_Time();
	&GetTables();
	&GetLoadFiles();
	&GetImportFiles();
	open(HTML, "$MasterHTMLDirectory/mysql_monitor_v400.htm");
	read(HTML,$htmlFile,30000);
	close(HTML);
	
	$htmlFile =~ s/HELP_URL/$HelpURL/;
	$htmlFile =~ s/TABLE_PLACE_HOLDER/$table_list/;
	$htmlFile =~ s/LOAD_FILE_PLACE_HOLDER/$load_file_table_list/;
	$htmlFile =~ s/IMPORT_FILE_PLACE_HOLDER/$import_file_table_list/;
	$htmlFile =~ s/ACTION_RESULTS/$table/;
	$htmlFile =~ s/PASSWORD_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD2_PLACE_HOLDER//;
	$htmlFile =~ s/PASSWORD/$the_password/;
	$htmlFile =~ s/CONVERT_DATE/$date/;
	$htmlFile =~ s/CONVERT_TIME/$unix_time/;
	$htmlFile =~ s/virtual></virtual>$sql_command</;
	print $htmlFile;
	exit 0;
}

exit 0;

#--------------------------------------------------------------------
sub SubmitQuery()
{
	$sql_command =~ s/[\r\n;]//g;
	$query_results = "$sql_command\n\n";
	$sth = $dbh->Query($sql_command);
	if($Mysql::db_errstr)
	{
		$query_results = "$sql_command\n\n";
		$query_results .= $Mysql::db_errstr;
		return;
	}
	$query_results .= "OK\n\n";
	$_ = $sql_command;
	if(/SELECT/)
	{
		$numberOfRows = $sth->numrows; 
		$query_results .= "$numberOfRows Rows SELECTED\n\n";
		$numberOfFields = split(/,/,$_);
		if($numberOfRows > 0)
		{
			$sth->DataSeek(0);
			for($i=0;$i<$numberOfRows;$i++)
			{
				@arr = $sth->FetchRow; 
				for($j=0;$j<$numberOfFields;$j++)
				{
					$query_results .= "@arr[$j],";
				}
				chop($query_results);
				$query_results .= "\n";
			}
		}
	}
}
#--------------------------------------------------------------------
sub GetTables()
{
	$mysql_command = "SHOW TABLES";
	$sth = $dbh->Query($mysql_command);
	if($Mysql::db_errstr)
	{
		print $Mysql::db_errstr;
		exit 0;
	}
	$numberOfRows = $sth->numrows; 
	$table_list = "<P><SELECT NAME=\"selected_table\" SIZE=5>\n";
  
	if($numberOfRows > 0)
	{
		$sth->DataSeek(0);
		for($i=0;$i<$numberOfRows;$i++)
		{
			@arr = $sth->FetchRow; 
			$table_list .= "<OPTION>@arr[0]\n";
		}
	}
	$table_list .= "</SELECT></P>";
}
# ----------------------------------------------
sub DumpTable()
{
	if($selected_table eq "")
	{
		print "Please select a table to dump.";
		exit 0;
	}
	if($DB_Password ne "")
	{
		$dump_file = `mysqldump --user=$DB_User --password=$DB_Password $DB_Name $selected_table`;
	}
	else
	{
		$dump_file = `mysqldump --user=$DB_User  $DB_Name $selected_table`;
	}
}

# ----------------------------------------------
sub Convert_IP_To_Decimal()
{
	@ip_seg_arr = split(/\./,$IPAddress);
	$decimal_ip_address = 256 * 256 *256 * $ip_seg_arr[0] + 256 * 256 * $ip_seg_arr[1] + 256 * $ip_seg_arr[2] + $ip_seg_arr[3];
}

# ----------------------------------------------------
sub Handle_Notification()
{
	# Open The Mail Program
   if($Notification_email_address eq "")
   {
   		return;
   	}
   	
   
   open(MAIL, "|$Mailprog -t") || die "Can't open $Mailprog!\n"; 

   print MAIL "To: $Notification_email_address\n";
   print MAIL "From: someone\@somewhere.com \n";

   print MAIL "Subject: MySQL Monitor Use \n\n";
   
    print MAIL "IP Address: $IPAddress\n\n";
    
	close(MAIL);
}
# ----------------------------------------------
sub LoadTable()
{
	$_ = $load_file_name;
	
	if(/\.gz/)
	{
		`gunzip $LoadDirectory/$load_file_name`;
		$load_file_name =~ s/\.gz//;
	}
	
	if($load_file_name eq "")
	{
		print "Please enter a file name to be loaded";
		exit 0;
	}
	if(!open(DATA, "$LoadDirectory/$load_file_name"))
	{
		print "$LoadDirectory/$load_file_name could not be opened";
		exit 0;
	}
	
	if($drop_table eq "T")
	{	
		if($selected_table eq "")
		{
			print "Please select a table to drop.";
			exit 0;
		}
		$mysql_command = "DROP TABLE $selected_table";
		$sth = $dbh->Query($mysql_command);
		if($Mysql::db_errstr)
		{
			print "$mysql_command<br>";
			print  "$Mysql::db_errstr";
			exit 0;
		}
	}
	
	
	$create_flag = 1;
	$dataFile = "";
	while($_ = <DATA>)
	{
		chop($_);
		if(($_ ne "") && (substr($_,0,1) ne "#") && (substr($_,0,1) ne "-"))
		{
			if($create_flag == 1)
			{
				
				if(/;/)
				{
					$dataFile .= "$_\n";
					$create_flag = 0;
				}
				else
				{
					$dataFile .= "$_";
					if(/CREATE/) # get the table name
					{
						@create_arr = split(/ /,$_);
						$created_table_name = $create_arr[2];
					}
				}
			}
			else
			{
				$dataFile .= "$_\n";
			}
		}
	}
	close(DATA);
	
	@sqlCommandArr = split(/\n/,$dataFile);
	foreach $sql_command (@sqlCommandArr)
	{
		$sth = $dbh->Query($sql_command);
		#print "$sql_command<br>";
		if($Mysql::db_errstr)
		{
			print "$sql_command<br>";
			print  "$Mysql::db_errstr";
			exit 0;
		}
	}
}
# ----------------------------------------------
sub ExportData()
{
	if($selected_table eq "")
	{
		print "Please select a table to export.";
		exit 0;
	}
	if($export_file_name eq "")
	{
		print "Please enter a file name to be exported.";
		exit 0;
	}
	if($export_format eq "")
	{
		print "Please select a format in which the data will be exported.";
		exit 0;
	}
	if(!open(DATA, ">$ExportDirectory/$export_file_name"))
	{
		print "$ExportDirectory/$export_file_name could not be opened.<br>Please check the permissions of the directory.";
		exit 0;
	}
	
	$mysql_command = "SHOW COLUMNS FROM $selected_table";
	$sth = $dbh->Query($mysql_command);
	$numberOfColumns = $sth->numrows; 
	
	$select_command = "SELECT ";
	
	$export_table = "";
	if($numberOfColumns > 0)
	{
		$sth->DataSeek(0);
		for($i=0;$i<$numberOfColumns;$i++)
		{
			@column_arr = $sth->FetchRow; 
			#print "$i. $column_arr[0] $column_arr[1]<br>";
			if($i == 0)
			{
				$select_command .= "$column_arr[0]";
				$where_column = $column_arr[0];
			}
			else
			{
				$select_command .= ",$column_arr[0]";
			}
		}
	}
	
	$select_command .= " FROM $selected_table";
	
	$sth = $dbh->Query($select_command);
	if($Mysql::db_errstr)
	{
		print "$select_command<br>";
		print  "$Mysql::db_errstr";
		exit 0;
	}
		
		
	$numberOfRows = $sth->numrows; 
	if($numberOfRows > 0)
	{
		$sth->DataSeek(0);
		for($i=0;$i<$numberOfRows;$i++)
		{
			@data_arr = $sth->FetchRow; 
			for($j=0;$j<$numberOfColumns;$j++)
			{
				if($j==0)
				{
					$export_table .= $data_arr[0];
				}
				else
				{
					if($export_format eq "csv")
					{
						$export_table .= ",$data_arr[$j]";
					}
					if($export_format eq "tsv")
					{
						$export_table .= "\t$data_arr[$j]";
					}
					if($export_format eq "osv")
					{
						$export_table .= ":$data_arr[$j]";
					}
				}
			}
			$export_table .= "\n";
		}
	}
	
	print DATA $export_table;
	close(DATA);
	
}

# ----------------------------------------------
sub ImportData()
{
	if($selected_table eq "")
	{
		print "Please select a table in which the data will be imported.";
		exit 0;
	}
	if($import_file_name eq "")
	{
		print "Please enter a file name to be imported.";
		exit 0;
	}
	
	$_ = $import_file_name;
	
	if(/\.gz/)
	{
		`gunzip $ImportDirectory/$import_file_name`;
		$import_file_name =~ s/\.gz//;
	}
	
	if($import_format eq "")
	{
		print "Please select a format in which the data will be imported.";
		exit 0;
	}
	if(!open(DATA, "$ImportDirectory/$import_file_name"))
	{
		print "$ImportDirectory/$import_file_name could not be opened.<br>Please check the permissions of the directory.";
		exit 0;
	}
	
	if($import_delete_entries eq "T")
	{
		$mysql_command = "DELETE FROM $selected_table";
		$sth = $dbh->Query($mysql_command);
		if($Mysql::db_errstr)
		{
			print "$mysql_command<br>";
			print  "$Mysql::db_errstr";
			exit 0;
		}
	}
	
	
	$mysql_command = "SHOW COLUMNS FROM $selected_table";
	$sth = $dbh->Query($mysql_command);
	$numberOfColumns = $sth->numrows; 
	
	$insert_command_start = "INSERT INTO $selected_table (";
	
	if($numberOfColumns > 0)
	{
		$sth->DataSeek(0);
		for($i=0;$i<$numberOfColumns;$i++)
		{
			@column_arr = $sth->FetchRow; 
			#print "$i. $column_arr[0] $column_arr[1]<br>";
			
			if($i == 0)
			{
				$insert_command_start .= "$column_arr[0]";
			}
			else
			{
				$insert_command_start .= ",$column_arr[0]";
			}
			
			$_ = $column_arr[1];
			
			if(/char/i || /varchar/i || /blob/i || /text/i || /enum/i || /set/i)
			{
				$string_type[$i] = 1;
				#print "$_ $string_type[$i]<br>";
			}
			else
			{
				$string_type[$i] = 0;
				#print "$_ $string_type[$i]<br>";
			}
		}
	}
	$insert_command_start .= ") VALUES (";
	
	#now read the data line by line and INSERT into table
	$numberOfImportedEntries = 0;
	while($_ = <DATA>)
	{
		chop($_); # get rid of first \n or \r
		if((substr($_,-1,1) eq "\r") || (substr($_,-1,1) eq "\n")) # get rid of second \r or \n if present
		{
			chop($_);
		}
		
		if($import_format eq "csv")
		{
			@line_arr = split(/,/,$_);
		}
		if($import_format eq "tsv")
		{
			@line_arr = split(/\t/,$_);
		}
		if($import_format eq "osv")
		{
			@line_arr = split(/:/,$_);
		}
		
		$insert_command = $insert_command_start;
		for($j=0;$j<$numberOfColumns;$j++)
		{
			if($j == 0)
			{
				if($string_type[$j] == 1)
				{
					$insert_command .= "\'$line_arr[$j]\'";
				}
				else
				{
					$insert_command .= "$line_arr[$j]";
				}
			}
			else
			{
				if($string_type[$j] == 1)
				{
					$insert_command .= ",\'$line_arr[$j]\'";
				}
				else
				{
					$insert_command .= ",$line_arr[$j]";
				}
			}
		}
		$insert_command .= ")";
		$sth = $dbh->Query($insert_command);
		if($Mysql::db_errstr)
		{
			print "$insert_command<br>";
			print  "$Mysql::db_errstr";
			exit 0;
		}
		$numberOfImportedEntries++;
	}
}
# ----------------------------------------------
sub GetLoadFiles()
{
	if(opendir(THE_DIR,$LoadDirectory))
	{
		@allfiles = grep(!/^\.\.?$/, readdir(THE_DIR));
		closedir(THE_DIR);
		
		$load_file_table_list = "<P><SELECT NAME=\"load_file\">\n";
	  
	  	foreach $fileName (@allfiles)
	  	{
			$load_file_table_list .= "<OPTION>$fileName\n";
		}
	
		$load_file_table_list .= "</SELECT></P>";
	}
}
# ----------------------------------------------
sub GetImportFiles()
{
	if(opendir(THE_DIR,$ImportDirectory))
	{
		@allfiles = grep(!/^\.\.?$/, readdir(THE_DIR));
		closedir(THE_DIR);
		
		$import_file_table_list = "<P><SELECT NAME=\"import_file\">\n";
	  
	  	foreach $fileName (@allfiles)
	  	{
			$import_file_table_list .= "<OPTION>$fileName\n";
		}
	
		$import_file_table_list .= "</SELECT></P>";
	}
}
# ----------------------------------------------
sub ShowStructure()
{
	if($selected_table eq "")
	{
		print "Please select a table.";
		exit 0;
	}
	
	$table_structure = "Table structure for table $selected_table\n\n";
	
	$mysql_command = "SHOW COLUMNS FROM $selected_table";
	$sth = $dbh->Query($mysql_command);
	$numberOfColumns = $sth->numrows; 
	
	if($numberOfColumns > 0)
	{
		$sth->DataSeek(0);
		for($i=0;$i<$numberOfColumns;$i++)
		{
			@column_arr = $sth->FetchRow; 
			$table_structure .= "$column_arr[0]";
			$spaces = 16 - length($column_arr[0]);
			for($j=0;$j<$spaces;$j++)
			{
				$table_structure .= " ";
			}
			$table_structure .= " $column_arr[1]\n";
			    
		}
	}
	$table_structure_edit_box = "<TEXTAREA NAME=\"\" ROWS=10 COLS=50 WRAP=virtual>TABLE_STRUCTURE</TEXTAREA></CENTER>";
	$table_structure_edit_box =~ s/TABLE_STRUCTURE/$table_structure/;
}
#--------------------------------------------------------------------
sub Show_Table_Sizes()
{
	$table_entry = "<TR>
         <TD>
            <CENTER><FONT SIZE=\"-2\" FACE=\"Arial\">TABLE_NAME</FONT></CENTER>
         </TD>
         <TD>
            <P ALIGN=right><FONT SIZE=\"-2\" FACE=\"Arial\">TABLE_SIZE</FONT></P>
         </TD>
         <TD>
            <P ALIGN=right><FONT SIZE=\"-2\" FACE=\"Arial\">MAX_SIZE</FONT></P>
         </TD>
      </TR>";
      
      
	$table = "<FONT SIZE=\"-2\" FACE=\"Arial\"><TABLE BORDER=0 WIDTH=\"100%\">
      <TR>
         <TD>
            <CENTER><FONT SIZE=\"-2\" FACE=\"Arial\"><B>Table
            Name</B></FONT></CENTER>
         </TD>
         <TD>
            <CENTER><FONT SIZE=\"-2\" FACE=\"Arial\"><B>Size
            (MB)</B></FONT></CENTER>
         </TD>
         <TD>
            <CENTER><FONT SIZE=\"-2\" FACE=\"Arial\"><B>Max Size
            (MB)</B></FONT></CENTER>
         </TD>
      </TR>
      TABLE_PLACEHOLDER
      <TR>
         <TD>
            <P></P>
         </TD>
         <TD>
            <P></P>
         </TD>
         <TD>
            <P></P>
         </TD>
      </TR>
      <TR>
         <TD>
            <P ALIGN=right><FONT SIZE=\"-2\" FACE=\"Arial\"><B>Total DB
            Size:</B></FONT></P>
         </TD>
         <TD>
            <P ALIGN=right><FONT SIZE=\"-2\" FACE=\"Arial\"><B>TOTAL_DB_SIZE</B></FONT></P>
         </TD>
         <TD>
            <P></P>
         </TD>
      </TR>
   </TABLE>";
   
	$mysql_command = "SHOW TABLE STATUS ";
	$sth = $dbh->Query($mysql_command);
	if($Mysql::db_errstr)
	{
		$table_sizes = "$mysql_command<br>";
		$table_sizes .= $Mysql::db_errstr;
		return;
	}
	$numberOfRows = $sth->numrows; 
	$totalDBSize = 0;
	$table_rows = "";
	
	# name, type, row_format, rows, avg_row_length, data_length, max_data_length, index_length, data_free
	# http://dev.mysql.com/doc/mysql/en/SHOW_TABLE_STATUS.html
	if($numberOfRows > 0)
	{
		$sth->DataSeek(0);
		if($selected_table eq "") 
		{
			for($i=0;$i<$numberOfRows;$i++)
			{
				@row_arr = $sth->FetchRow; 
				$tEntry = $table_entry;
				$table_size = $row_arr[5] + $row_arr[7];
				$totalDBSize += $row_arr[5] + $row_arr[7];
				$table_size /= 1048576;  # convert to MB
				$table_size = sprintf("%6.3f",$table_size);
				$max_size = $row_arr[6]/1048576;
				$max_size = sprintf("%6.3f",$max_size);
				
				$tEntry =~ s/TABLE_NAME/$row_arr[0]/;
				$tEntry =~ s/TABLE_SIZE/$table_size/;
				$tEntry =~ s/MAX_SIZE/$max_size/;
				$table_rows .= "$tEntry\n";
				    
			}
			$totalDBSize /= 1048576;  # convert to MB
			$totalDBSize = sprintf("%6.3f",$totalDBSize);
			$table =~ s/TABLE_PLACEHOLDER/$table_rows/;
			$table =~ s/TOTAL_DB_SIZE/$totalDBSize/;
		}
		else
		{
			for($i=0;$i<$numberOfRows;$i++)
			{
				@row_arr = $sth->FetchRow; 
				$totalDBSize += $row_arr[5] + $row_arr[7];
				if($row_arr[0] eq $selected_table)
				{
					$tEntry = $table_entry;
					$table_size = $row_arr[5] + $row_arr[7];
					$table_size /= 1048576;  # convert to MB
					$table_size = sprintf("%6.3f",$table_size);
					$max_size = $row_arr[6]/1048576;
					$max_size = sprintf("%6.3f",$max_size);
					
					$tEntry =~ s/TABLE_NAME/$row_arr[0]/;
					$tEntry =~ s/TABLE_SIZE/$table_size/;
					$tEntry =~ s/MAX_SIZE/$max_size/;
					$table_rows .= "$tEntry\n";
				}
				    
			}
			$totalDBSize /= 1048576;  # convert to MB
			$totalDBSize = sprintf("%6.3f",$totalDBSize);
			$table =~ s/TABLE_PLACEHOLDER/$table_rows/;
			$table =~ s/TOTAL_DB_SIZE/$totalDBSize/;
		}
	}
}
#--------------------------------------------------------------------
sub Convert_Time()
{
	if($date ne "")
	{
		($day,$mon,$year) = split(/\//,$date);
		$mon--;
		$unix_time = timelocal(0,0,0,$day,$mon,$year);
	}
	elsif($unix_time ne "")
	{
		($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($unix_time);
		$mon++;
		if($year < 1900)
		{
			$year+= 1900;
		}
		$date = "$mday/$mon/$year";
	}
}
